(*
// LegoCtl.cpp : Implementation of the CLegoCtrl OLE control class.
// by Charles H. Huddleston
#include "stdafx.h"
#include "Lego.h"
#include "LegoCtl.h"
#include "LegoPpg.h"
DWORD InputThread(LPVOID pParam);


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CLegoCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CLegoCtrl, COleControl)
	//{{AFX_MSG_MAP(CLegoCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_MESSAGE(WM_FIREONPRESS, OnFireOnPress)
	ON_MESSAGE(WM_FIREONRELEASE, OnFireOnRelease)
	ON_MESSAGE(WM_FIREONTEMP, OnFireOnTemperature)
	ON_MESSAGE(WM_FIREONANGLE, OnFireOnAngle)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CLegoCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CLegoCtrl)
	DISP_PROPERTY_NOTIFY(CLegoCtrl, "SerialPort", m_SerialPort, OnSerialPortChanged, VT_BSTR)
	DISP_FUNCTION(CLegoCtrl, "StartLegos", StartLegos, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CLegoCtrl, "StopLegos", StopLegos, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CLegoCtrl, "TurnOn", TurnOn, VT_BOOL, VTS_I2)
	DISP_FUNCTION(CLegoCtrl, "TurnOff", TurnOff, VT_BOOL, VTS_I2)
	DISP_FUNCTION(CLegoCtrl, "Reverse", Reverse, VT_BOOL, VTS_I2)
	DISP_FUNCTION(CLegoCtrl, "SetPower", SetPower, VT_BOOL, VTS_I2 VTS_I2)
	DISP_FUNCTION(CLegoCtrl, "SetDirection", SetDirection, VT_BOOL, VTS_I2 VTS_BOOL)
	DISP_FUNCTION(CLegoCtrl, "IsPressed", IsPressed, VT_BOOL, VTS_I2)
	DISP_FUNCTION(CLegoCtrl, "GetTemperature", GetTemperature, VT_R8, VTS_I2)
	DISP_FUNCTION(CLegoCtrl, "GetAngle", GetAngle, VT_I2, VTS_I2)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CLegoCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CLegoCtrl, COleControl)
	//{{AFX_EVENT_MAP(CLegoCtrl)
	EVENT_CUSTOM("OnPress", FireOnPress, VTS_I2)
	EVENT_CUSTOM("OnRelease", FireOnRelease, VTS_I2)
	EVENT_CUSTOM("OnTemperatureChange", FireOnTemperatureChange, VTS_I2  VTS_R8)
	EVENT_CUSTOM("OnAngleChange", FireOnAngleChange, VTS_I2  VTS_I2)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CLegoCtrl, 1)
	PROPPAGEID(CLegoPropPage::guid)
END_PROPPAGEIDS(CLegoCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CLegoCtrl, "LEGO.LegoCtrl.1",
	0x93b2a113, 0x8ff2, 0x11d0, 0x86, 0x6, 0, 0xa0, 0x24, 0x69, 0x26, 0xab)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CLegoCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DLego =
		{ 0xd3887d21, 0xa390, 0x11d0, { 0x8e, 0x41, 0, 0xa0, 0x24, 0x69, 0x26, 0xab } };
const IID BASED_CODE IID_DLegoEvents =
		{ 0xd3887d22, 0xa390, 0x11d0, { 0x8e, 0x41, 0, 0xa0, 0x24, 0x69, 0x26, 0xab } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwLegoOleMisc =
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CLegoCtrl, IDS_LEGO, _dwLegoOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::CLegoCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CLegoCtrl

BOOL CLegoCtrl::CLegoCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_LEGO,
			IDB_LEGO,
			TRUE,                       //  Insertable
			_dwLegoOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

////////////////////////////////////////////////////////////////////////////
// Globals

HANDLE hCom;
BOOL running;
UINT timer;
BOOL pressed[8]={FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE};
short rotation[8]={0,0,0,0,0,0,0,0};
DWORD value[8];

/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::CLegoCtrl - Constructor

CLegoCtrl::CLegoCtrl()
{
	InitializeIIDs(&IID_DLego, &IID_DLegoEvents);
	// Load the serial port name from the system registry
	HKEY legokey;
	DWORD result;
	LONG error=RegCreateKeyEx(HKEY_CLASSES_ROOT,
							  (LPCTSTR)"LEGO.LegoCtrl.1",
							  0,
							  NULL,
							  REG_OPTION_NON_VOLATILE,
							  KEY_ALL_ACCESS,
							  NULL,
							  &legokey,
							  &result);
	if(error==ERROR_SUCCESS)
	{
		if(result==REG_CREATED_NEW_KEY)
		{
			m_SerialPort="COM2";
			OnSerialPortChanged();
		}
		else
		{
			DWORD size=10;
			char buffer[10];
			error=RegQueryValueEx(legokey,
								  (LPCTSTR)"SerialPort",
								  NULL,
								  NULL,
								  (unsigned char* )buffer,
								  &size);
			if(error==ERROR_SUCCESS)
			{
				m_SerialPort=CString(buffer);
			}
			else
			{
				m_SerialPort="COM2";
				OnSerialPortChanged();
			}
		}							
	}
	else
	{
		MessageBox((LPCTSTR)"Unable to access system registry");
	}

	// Load the control's icon
	icon=LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ABOUTDLL));
}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::~CLegoCtrl - Destructor

CLegoCtrl::~CLegoCtrl()
{
	if(running)
		StopLegos();
}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::OnDraw - Drawing function

void CLegoCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->DrawIcon(rcBounds.TopLeft(), icon);
}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::DoPropExchange - Persistence support

void CLegoCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::OnResetState - Reset control to default state

void CLegoCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl::AboutBox - Display an "About" box to the user

void CLegoCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_LEGO);
	dlgAbout.DoModal();
}

////////////////////////////////////////////////////////////////////////////
// The Function to send 0x02 every 2 seconds

VOID CALLBACK TimerProc(HWND  hwnd, UINT  uMsg, UINT  idEvent, DWORD  dwTime) 
{
	if(running)
	{
		BYTE alive=0x02;
		DWORD numbytes;
	
		if(WriteFile(hCom, &alive, 1, &numbytes, NULL)==FALSE)
		{
			KillTimer(NULL, timer);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// Function for sending commands to lego box

BOOL CLegoCtrl::SendCommand(BYTE command, int port)
{
	if(running)
	{
		if(0<port && port<9)
		{
			BYTE buffer[2];
			buffer[0]=command;
			buffer[1]=1<<(port-1);
		
			DWORD numbytes;

			if(WriteFile(hCom, buffer, 2, &numbytes, NULL)==FALSE)
			{
				return FALSE;
			}
			return TRUE;
		}
		else
		{
			MessageBox((LPCTSTR)"Bad port number");
			return FALSE;
		}
	}
	else
	{
		return FALSE;
	}
}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl Command Methods

BOOL CLegoCtrl::StartLegos() 
{
	// If we are already started, don't start again
	if(running)
		return TRUE;

	DCB dcb;
	DWORD dwError;
	BOOL fResult;

	// Open serial open
	hCom = CreateFile(m_SerialPort,
		GENERIC_READ | GENERIC_WRITE,
		0,    /* comm devices must be opened w/exclusive-access */
		NULL, /* no security attrs */
		OPEN_EXISTING, /* comm devices must use OPEN_EXISTING */
		0,	
		NULL  /* hTemplate must be NULL for comm devices */
		);
	if (hCom == INVALID_HANDLE_VALUE)
	{
		dwError = GetLastError();
		MessageBox((LPCTSTR)"Can't create serial port handle\n");
		return FALSE;
	}
	fResult = GetCommState(hCom, &dcb);
	if (!fResult) 
	{
		MessageBox((LPCTSTR)"Can't get initial com port parameters\n");
		return FALSE;
	}
	dcb.BaudRate = 9600;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	// Reset the com port to the new configuration
	fResult = SetCommState(hCom, &dcb);
	if (!fResult) 
	{
		MessageBox((LPCTSTR)"Can't set communication parameters\n");
		return FALSE;
	}

	// Set communications timeout values
	COMMTIMEOUTS to;
	to.ReadIntervalTimeout=0;
    to.ReadTotalTimeoutMultiplier=500; 
    to.ReadTotalTimeoutConstant=1000; 
    to.WriteTotalTimeoutMultiplier=0; 
    to.WriteTotalTimeoutConstant=0;
	fResult = fResult && SetCommTimeouts(hCom, &to);

	// Send greeting to lego box
	char buffer[]="p\0###Do you byte, when I knock?$$$";
	DWORD numbytes;
	WriteFile(hCom, buffer, 34, &numbytes, NULL);
	if(numbytes!=34)
	{
		MessageBox((LPCTSTR)"Write failed");
	}

	//Read in ###Just a bit off the block!$$$
	char info[150];
	int current=0, count=0;
	BOOL found=FALSE;
	while(!found)
	{
		if(ReadFile(hCom, &info[current], 1, &numbytes, NULL) && numbytes!=0)
		{
			if(info[current]=='$')
				count++;
			if(count==3)
				found=TRUE;
			current++;
		}
		else
		{
			MessageBox((LPCTSTR)"Lego Control Box is not functioning.");
			StopLegos();
			return FALSE;
		}
	}

	// Start the timer for sending alives
	timer=::SetTimer(NULL, 0, 2000, (TIMERPROC)TimerProc );
	if(timer==0)
	{
		MessageBox((LPCTSTR)"Failed to start timer");
		StopLegos();
		return FALSE;
	}

	// Start the input thread
	running=TRUE;
	DWORD dwThreadID;
	hInputThread=CreateThread((LPSECURITY_ATTRIBUTES) NULL,
		0,
		(LPTHREAD_START_ROUTINE) InputThread,
		this,
		0,
		&dwThreadID);

	return TRUE;
}

BOOL CLegoCtrl::StopLegos() 
{
	CloseHandle(hCom);
	::KillTimer(NULL, timer);
	running=FALSE;
	return TRUE;
}

BOOL CLegoCtrl::TurnOn(short port) 
{
	return 	SendCommand(LEGO_ON, port);
}

BOOL CLegoCtrl::TurnOff(short port)
{
	return SendCommand(LEGO_OFF, port);
}

BOOL CLegoCtrl::Reverse(short port) 
{
	return SendCommand(LEGO_REVERSE, port);
}

BOOL CLegoCtrl::SetPower(short port, short power) 
{
	if(power==0)
	{
		return SendCommand(LEGO_POWER_0, port);
	}
	else if(0<power && power<=8)
	{
		return SendCommand(LEGO_SETPOWER | (power-1), port);
	}
	else
	{
		MessageBox((LPCTSTR)"SetPower: Bad parameter");
		return 0;
	}
}

BOOL CLegoCtrl::SetDirection(short port, BOOL direction) 
{
	if(direction==FALSE)
	{
		return SendCommand(LEGO_LEFT, port);
	}
	else if(direction==TRUE)
	{
		return SendCommand(LEGO_RIGHT, port);
	}
	else
	{
		MessageBox((LPCTSTR)"SetDirection: Bad Parameter");
		return FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl State Methods

BOOL CLegoCtrl::IsPressed(short port) 
{
	if(0<port && port<9 && running)
	{
		return pressed[port-1];
	}
	return FALSE;
}

double CLegoCtrl::GetTemperature(short port) 
{
	return ((double)760-value[port-1])/4.4+32;
}

short CLegoCtrl::GetAngle(short port) 
{
	return rotation[port-1];
}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl Property Change Handler

void CLegoCtrl::OnSerialPortChanged() 
{
	HKEY legokey;
	DWORD result;
	LONG error=RegCreateKeyEx(HKEY_CLASSES_ROOT,
							  (LPCTSTR)"LEGO.LegoCtrl.1",
							  0,
							  NULL,
							  REG_OPTION_NON_VOLATILE,
							  KEY_ALL_ACCESS,
							  NULL,
							  &legokey,
							  &result);
	if(error==ERROR_SUCCESS)
	{
		error=RegSetValueEx(legokey,
					  (LPCTSTR)"SerialPort",
					  0,
					  REG_SZ,
					  (const unsigned char* )m_SerialPort.GetBuffer(5),
					  m_SerialPort.GetLength()+1);
		if(error!=ERROR_SUCCESS)
		{
			MessageBox((LPCTSTR)"Unable to write to system registry");
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// The thread used for reading input

void CheckInput(short port, short index);
BYTE buffer[19];
HWND hwnd;
CLegoCtrl* ctrl;

DWORD InputThread(LPVOID pParam)
{
	ctrl=(CLegoCtrl* )pParam;
	DWORD numBytes;
	BYTE sum;

	while(running)
	{
		numBytes=0;
		int total=0;
		while(total!=19)
		{
			ReadFile(hCom, &buffer[total], 19-total, &numBytes, NULL);
			total+=numBytes;
		}

		// Check the checksum
		sum=0;
		for(int i=0; i<19; i++)
		{
			sum+=buffer[i];
		}
		if((sum&0xFF) != 0xFF)
		{
			ctrl->StopLegos();
			return 1;
		}
		else
		{
			CheckInput(3, 2);
			CheckInput(7, 4);
			CheckInput(2, 6);
			CheckInput(6, 8);
			CheckInput(1, 10);
			CheckInput(5, 12);
			CheckInput(0, 14);
			CheckInput(4, 16);
		}
	}
	return 0;
}

void CheckInput(short port, short index)
{
	// Touch info
	BOOL TouchEvent=FALSE;
	if(buffer[index]==0x2E)
	{
		TouchEvent=TRUE;
		if(pressed[port]==FALSE)
		{
			PostMessage(ctrl->m_hWnd,
				WM_FIREONPRESS,
				(WPARAM)port+1,
				(LPARAM)NULL);
			pressed[port]=TRUE;
		}
	}
	else
	{
		if(pressed[port]==TRUE)
		{
			PostMessage(ctrl->m_hWnd,
				WM_FIREONRELEASE,
				(WPARAM)port+1,
				(LPARAM)NULL);
			pressed[port]=FALSE;
			TouchEvent=TRUE;
		}
	}

	// Light and Temperature info
	DWORD newvalue=int(buffer[index])*4+(int(buffer[index+1]&0xC0)/64);
	if(value[port]!=newvalue)
	{
		value[port]=newvalue;
		if(!TouchEvent && value[port]!=0x3FF)
		{
			PostMessage(ctrl->m_hWnd,
					WM_FIREONTEMP,
					(WPARAM)port+1,
					(LPARAM)value[port]);
		}
	}

	// Angle Info
	short direction;
	unsigned char TurnAmount;
	if(buffer[index+1] & 0x04)
		direction=LEGO_CLOCKWISE;
	else direction=LEGO_COUNTERCW;
	TurnAmount=(buffer[index+1] & 0x03);
	switch(TurnAmount)
	{
		case 0x01:
		case 0x02:
		case 0x03:
			if(direction==LEGO_CLOCKWISE)
				rotation[port]=(rotation[port]+TurnAmount)%16;
			else rotation[port]=(16+rotation[port]-TurnAmount)%16;
			PostMessage(ctrl->m_hWnd,
					WM_FIREONANGLE,
					(WPARAM)port+1,
					(LPARAM)rotation[port]);
			break;
		default:
			break;
	}

}


/////////////////////////////////////////////////////////////////////////////
// CLegoCtrl Message Handlers for Firing Events

LRESULT CLegoCtrl::OnFireOnPress(WPARAM wParam, LPARAM lParam)
{
	FireOnPress((short)wParam);
	return TRUE;
}

LRESULT CLegoCtrl::OnFireOnRelease(WPARAM wParam, LPARAM lParam)
{
	FireOnRelease((short)wParam);
	return TRUE;
}

LRESULT CLegoCtrl::OnFireOnTemperature(WPARAM wParam, LPARAM lParam)
{
	double temp=(double)(760-lParam)/4.4+32;
	if(temp>=0)
	{
		FireOnTemperatureChange((short)wParam, temp);
	}
	return TRUE;
}

LRESULT CLegoCtrl::OnFireOnAngle(WPARAM wParam, LPARAM lParam)
{
	FireOnAngleChange((short)wParam, (short)lParam);
	return TRUE;
}

*)
