unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, RXSlider, ComCtrls, LD70909;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListBox1: TListBox;
    TabSheet2: TTabSheet;
    cbIn1: TCheckBox;
    cbIn2: TCheckBox;
    cbIn3: TCheckBox;
    cbIn4: TCheckBox;
    cbIn5: TCheckBox;
    cbIn6: TCheckBox;
    cbIn7: TCheckBox;
    cbIn8: TCheckBox;
    edIn1: TEdit;
    edIn2: TEdit;
    edIn3: TEdit;
    edIn4: TEdit;
    edIn5: TEdit;
    edIn6: TEdit;
    edIn7: TEdit;
    edIn8: TEdit;
    edInA1: TEdit;
    edInA2: TEdit;
    edInA3: TEdit;
    edInA4: TEdit;
    edInA5: TEdit;
    edInA6: TEdit;
    edInA7: TEdit;
    edInA8: TEdit;
    RxSlider1: TRxSlider;
    Panel1: TPanel;
    Button2: TButton;
    RxSlider2: TRxSlider;
    RxSlider3: TRxSlider;
    RxSlider4: TRxSlider;
    RxSlider5: TRxSlider;
    RxSlider6: TRxSlider;
    RxSlider7: TRxSlider;
    RxSlider8: TRxSlider;
    cbO1: TCheckBox;
    cbO2: TCheckBox;
    cbO3: TCheckBox;
    cbO4: TCheckBox;
    cbO5: TCheckBox;
    cbO6: TCheckBox;
    cbO7: TCheckBox;
    cbO8: TCheckBox;
    cbStopInd: TCheckBox;
    edCommand: TEdit;
    btnSend: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure RxSlider1Change(Sender: TObject);
    procedure cbO1Click(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    hCom: THandle;
    RecMess: string;
    OldRecMess: string;
    WatchTime: DWord;
    LDInterface: TLDInterface;
    procedure AddToLog(s: string);
    procedure AddToCommandEdit(s: string);
    procedure SendIt(s: string);
    procedure CommError(ErrorCode: TCommError);
    procedure ConnectDone;
    procedure DisconnectDone;
    procedure InputChange;
    procedure UpdateAllInputs;
    procedure AngleInd(Port, Value: integer);
    procedure PressInd(Port: integer; Value: boolean);
    procedure ValueInd(Port, Value: integer);
    procedure ResetAllOutputs;
  public
    { Public declarations }
  end;

var
  Form1             : TForm1;

implementation

{$R *.DFM}

const
  HEXCHARS          = '0123456789ABCDEF';

{-------------------------------------------------------------}

procedure TForm1.FormCreate(Sender: TObject);
begin
  TabSheet2.Enabled := False;
  LDInterface := TLDInterface.Create;
  LDInterface.ComPort := 'COM2';
  LDInterface.OnCommError := CommError;
  LDInterface.OnInputChange := InputChange;
  LDInterface.OnConnect := ConnectDone;
  LDInterface.OnDisconnect := DisconnectDone;
  LDInterface.OnLogg := AddToLog;
end;

procedure TForm1.CommError(ErrorCode: TCommError);
begin
  if not (ErrorCode in [ceResynch, ceChecksum, ceStopped]) then
    ShowMessage(ErrorTexts[ErrorCode]);
end;

procedure TForm1.InputChange;
begin
  UpdateAllInputs;
end;

procedure TForm1.ConnectDone;
begin
  Button2.Caption := 'Disconnect';
  Button2.Tag := 1;
  TabSheet2.Enabled := True;
end;

procedure TForm1.DisconnectDone;
begin
  ResetAllOutputs;
  Button2.Caption := 'Connect';
  Button2.Tag := 0;
  TabSheet2.Enabled := False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  LDInterface.Free;
end;

procedure TForm1.AddToLog(s: string);
begin
  ListBox1.Items.Add(s);
  ListBox1.ItemIndex := Pred(ListBox1.Items.Count);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Button2.Tag = 1 then
    LDInterface.Disconnect
  else
    LDInterface.Connect
end;

procedure TForm1.UpdateAllInputs;
var
  i                 : integer;
begin
  for i := 0 to 7 do begin
    PressInd(i, LDInterface.Pressed[i]);
    ValueInd(i, LDInterface.Value[i]);
    AngleInd(i, LDInterface.Angle[i]);
  end;
  cbStopInd.Checked := LDInterface.Stopped;
end;

procedure TForm1.ResetAllOutputs;
begin
  cbO1.Checked := False;
  cbO2.Checked := False;
  cbO3.Checked := False;
  cbO4.Checked := False;
  cbO5.Checked := False;
  cbO6.Checked := False;
  cbO7.Checked := False;
  cbO8.Checked := False;
  RxSlider1.Value := 7;
  RxSlider2.Value := 7;
  RxSlider3.Value := 7;
  RxSlider4.Value := 7;
  RxSlider5.Value := 7;
  RxSlider6.Value := 7;
  RxSlider7.Value := 7;
  RxSlider8.Value := 7;
  Button10.Caption := 'R';
  Button11.Caption := 'R';
  Button12.Caption := 'R';
  Button13.Caption := 'R';
  Button14.Caption := 'R';
  Button15.Caption := 'R';
  Button16.Caption := 'R';
  Button17.Caption := 'R';
end;

procedure TForm1.PressInd(Port: integer; Value: boolean);
begin
  case Port of
    0: cbIn1.Checked := Value;
    1: cbIn2.Checked := Value;
    2: cbIn3.Checked := Value;
    3: cbIn4.Checked := Value;
    4: cbIn5.Checked := Value;
    5: cbIn6.Checked := Value;
    6: cbIn7.Checked := Value;
    7: cbIn8.Checked := Value;
  end
end;

procedure TForm1.ValueInd(Port, Value: integer);
begin
  case Port of
    0: edIn1.Text := IntToStr(Value);
    1: edIn2.Text := IntToStr(Value);
    2: edIn3.Text := IntToStr(Value);
    3: edIn4.Text := IntToStr(Value);
    4: edIn5.Text := IntToStr(Value);
    5: edIn6.Text := IntToStr(Value);
    6: edIn7.Text := IntToStr(Value);
    7: edIn8.Text := IntToStr(Value);
  end
end;

procedure TForm1.AngleInd(Port, Value: integer);
begin
  case Port of
    0: edInA1.Text := IntToStr(Value);
    1: edInA2.Text := IntToStr(Value);
    2: edInA3.Text := IntToStr(Value);
    3: edInA4.Text := IntToStr(Value);
    4: edInA5.Text := IntToStr(Value);
    5: edInA6.Text := IntToStr(Value);
    6: edInA7.Text := IntToStr(Value);
    7: edInA8.Text := IntToStr(Value);
  end
end;

procedure TForm1.RxSlider1Change(Sender: TObject);
var
  Cmd               : string;
begin
  with Sender as TRxSlider do begin
    LDInterface.SetPower([Tag], (Value and POWER_MASK)+1)
  end;
end;

procedure TForm1.cbO1Click(Sender: TObject);
var
  Cmd               : string;
begin
  with (Sender as TCheckBox) do begin
    if Checked then
      LDInterface.TurnOn([Tag])
    else
      LDInterface.TurnOff([Tag]);
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  Cmd               : string;
begin
  with (Sender as TButton) do begin
    if (Caption = 'R') then begin
      Caption := 'L';
      LDInterface.SetDir([Tag], dCW)
    end
    else begin
      Caption := 'R';
      LDInterface.SetDir([Tag], dCCW)
    end;
  end;
end;

procedure TForm1.AddToCommandEdit(s: string);
var
  i                 : integer;
  r                 : string;
begin
  r := '';
  for i := 1 to Length(s) do begin
    r := r + Format('%2.2x', [Ord(s[i])]) + ' ';
  end;
  edCommand.Text := r;
end;

procedure TForm1.btnSendClick(Sender: TObject);
var
  i                 : integer;
  s1                : string;
  s2                : string;
  State             : integer;
  v                 : integer;
  numbytes          : DWord;
begin
  s1 := UpperCase(edCommand.Text);
  s2 := '';
  State := 0;
  for i := 1 to Length(s1) do begin
    if Pos(s1[i], HEXCHARS) > 0 then begin
      case State of
        0: begin
            v := (Pos(s1[i], HEXCHARS) - 1);
            State := 1;
          end;
        1: begin
            v := (v shl 4) + (Pos(s1[i], HEXCHARS) - 1);
            s2 := s2 + Char(v);
            State := 0;
          end;
      end
    end
  end;
  if State = 0 then begin
    SendIt(s2);
  end
  else begin
    // Error, misformed hex
  end
end;

procedure TForm1.SendIt(s: string);
begin
  if LDInterface.Connected then
    LDInterface.Send(s);
end;

end.

